


.include 	"tn2313adef.inc"	;  tiny2313a



.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	Flagfazy=R22
.def	Temp7=R23
.def	Temp8=R24
.def	Temp9=R25


.dseg					; 

OZU: .byte 1				;  1   


;******************************************************************************

.EQU OneImp=0x640 			;     (1600 )
.EQU NylImp=0x578 			;     (1400 )
.EQU Chastota=0x4E20 			;  20000   (50)

;******************************************************************************

.cseg


.org 0
rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
					;  


.org INT0addr				; = 0x0001 External Interrupt Request 0
rjmp INT_0				;  INT0



;	.org   OC1Aaddr			; (=0x0004) Timer/Counter1 Compare Match A
;	rjmp OCR1A_COMP			;     OCR1A



;	.org   OC1Baddr			; (=0x000c) Timer/Counter1 Compare Match B
;	rjmp OCR1B_COMP			;     OCR1B



.org INT_VECTORS_SIZE


;******************************************************************************
;
;******************************************************************************

reset:									;  

	cli								;    


	ldi Temp,low(RamEnd)						;  	
	out SPL,Temp							;




INIT_ports:
	
	ldi Temp,0b00011000						;   "" ( 0-, 1- )
	out DDRB,Temp							; 000x000 - "" 
									; ( PB3 - 15  - OC1A ) -  (    )
									; ( PB4 - 16  - OC1B ) -  
	

	ldi Temp,0b00000000						;  _0   !
	out PortB,Temp							; 
																						 
												 
	ldi Temp,0b00000000						;   "D" (0-, 1-)
	out DDRD,Temp 							; 





INIT_ext_int:

	ldi Temp,(1<<ISC01)|(1<<ISC00)					;    INT0    
	out MCUCR,Temp


	ldi Temp,(1<<INT0)						;     INT0
	out GIMSK ,Temp






Timer1_Init:

	LDI Temp,high(NylImp)						;    1400  ( 1400  )
	OUT OCR1AH,Temp							;      
	LDI Temp,low(NylImp)							
	OUT OCR1AL,Temp       


	LDI Temp,high(NylImp)						;    1400  ( 1400  )
	OUT OCR1BH,Temp							;      
	LDI Temp,low(NylImp)							
	OUT OCR1BL,Temp 


	ldi Temp,(1<<COM1A1)|(1<<COM1B1)|(1<<wgm11)			;      ICR1 
	out TCCR1A,Temp							; *1 (     )


					
	ldi Temp,(1<<wgm13)|(1<<wgm12)|(1<<CS10)			;    = CK 1:1 
	out TCCR1B,Temp							;   !



	LDI Temp,high(Chastota)						;    20000  (   50 )
	OUT ICR1H,Temp							;      
	LDI Temp,low(Chastota)							
	OUT ICR1L,Temp 


						
;	ldi Temp,(1<<OCIE1A)|(1<<OCIE1B)				;    1- 
;	out TIMSK,Temp							;  OCR1A  OCR1B (  OC1A  OC1B )



	ldi Temp,0							;   
	out TCNT1H,Temp
	out TCNT1L,Temp


	ldi FlagFazy,1							;   ( 1= , 0=  )


	sei								;   
        



;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:



	
	rjmp Main_cicle			; 


;*******************************************************************************
;   INT0
;*******************************************************************************

INT_0:




	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4




	cpi FlagFazy,1			;       ?
	brne set_falling_edge		;  ,     "    "

	ldi Temp,(1<<ISC01)		;      "INT0" 
	out MCUCR,Temp

	ldi FlagFazy,0			;    (0= )



	LDI Temp,high(OneImp)		;    1600  ( 1600  )
	OUT OCR1AH,Temp			;      
	LDI Temp,low(OneImp)							
	OUT OCR1AL,Temp       


	LDI Temp,high(OneImp)		;    1600  ( 1600  )
	OUT OCR1BH,Temp			;      
	LDI Temp,low(OneImp)							
	OUT OCR1BL,Temp 

	rjmp out_1



set_falling_edge:			;     	



	ldi Temp,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,Temp


	ldi FlagFazy,1			;    (1= )


	LDI Temp,high(NylImp)		;    1400  ( 1400  )
	OUT OCR1AH,Temp			;      
	LDI Temp,low(NylImp)							
	OUT OCR1AL,Temp       


	LDI Temp,high(NylImp)		;    1400  ( 1400  )
	OUT OCR1BH,Temp			;      
	LDI Temp,low(NylImp)							
	OUT OCR1BL,Temp 

	rjmp out_1



;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    



